import BaseHTTPServer
from rt import tracker, notify
import time
import json
import re
import urlparse
from settings import RT_USERNAME, RT_PASSWORD, RT_BASE_URL, CONFIGS, HOST_NAME, PORT_NUMBER, get_ticket_template

token = "aij5wfhxpibkjp4spa5oq9u6ma"

# guarantee unicode string
_u = lambda t: t.decode('UTF-8', 'replace') if isinstance(t, str) else t

class MattermostRequest(object):

    def __init__(self, response_url=None, text=None, token=None, channel_id=None, team_id=None, command=None,
                 team_domain=None, user_name=None, channel_name=None):
        self.response_url = response_url
        self.text = text
        self.token = token
        self.channel_id = channel_id
        self.team_id = team_id
        self.command = command
        self.team_domain = team_domain
        self.user_name = user_name
        self.channel_name = channel_name

class RedirectHandler(BaseHTTPServer.BaseHTTPRequestHandler):

    def do_POST(self):
        # Extract the contents of the POST
        print "cenas"

        length = int(self.headers['Content-Length'])
        post_data = urlparse.parse_qs(self.rfile.read(length).decode('utf-8'))

        request = MattermostRequest()

        # Get POST data and initialize MattermostRequest object
        for key, valuez in post_data.iteritems():
            value = valuez[0]
            if key == 'response_url':
                request.response_url = value
            elif key == 'text':
                request.text = value
            elif key == 'token':
                request.token = value
            elif key == 'channel_id':
                request.channel_id = value
            elif key == 'team_id':
                request.team_id = value
            elif key == 'command':
                request.command = value
            elif key == 'team_domain':
                request.team_domain = value
            elif key == 'user_name':
                request.user_name = value
            elif key == 'channel_name':
                request.channel_name = value

        response_text = ''

        if request.token == token:
            response_text = self.print_tickets(request.text)

        print "%s %s" % (request.token, token)
        
	if response_text:
            data = {}
            # 'response_type' may also be 'in_channel'
            data['response_type'] = 'in_channel'
            data['username'] = 'RT'
            data['icon_url'] = 'https://tickets.tecnico.ulisboa.pt/static/images/favicon.png'
            data['text'] = response_text
            self.send_response(200)
            self.send_header("Content-type", "application/json")
            self.end_headers()
            self.wfile.write(json.dumps(data))
        return

    def print_tickets(self, ids):
        tickets = [x.strip('#') for x in ids.split(' ')]
        response = ''

        for id in tickets:
            ticket = tracker.get_ticket(self.parse_ticket(id))
            response += get_ticket_template(ticket)

        return response

    def parse_ticket(self, value):
        try:
            return int(value)
        except ValueError:
            parsed = urlparse.urlparse(value)
            return urlparse.parse_qs(parsed.query)['id'][0]


if __name__ == '__main__':

    server_class = BaseHTTPServer.HTTPServer
    httpd = server_class((HOST_NAME, PORT_NUMBER), RedirectHandler)
    print time.asctime(), "Server Starts - %s:%s" % (HOST_NAME, PORT_NUMBER)
    try:
        httpd.serve_forever()
    except KeyboardInterrupt:
        pass
    httpd.server_close()
    print time.asctime(), "Server Stops - %s:%s" % (HOST_NAME, PORT_NUMBER)
